import 'dart:async';

import 'package:flutter/services.dart';
import 'package:tradein_plugin/modal/student.dart';

class TradeinPlugin {
  static const MethodChannel _channel = const MethodChannel('tradein_plugin');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  // static Future<String?> get screenNavigate async {
  //   final String? navigate = await _channel.invokeMethod('screenNavigate');
  //   return navigate;
  // }

  static passValuesToNative(Student modal,
      {String value: '',
      required List arr,
      Map json: const {'': ''},
      bool isTrue: false}) {
    _channel.invokeMethod('getDynamicValues', {
      'value': value,
      'arr': arr,
      'json': json,
      'isTrue': isTrue,
      'modal': modal.toJson()
    });
  }

  static loadTradinPluginSDK() {
    _channel.invokeMethod('loadTradinPluginSDK');
  }

  static Future<String?> loadTradinPluginSDKWithValues<String>(String value1, String value2, String value3) async{
    final String? resultData = await _channel.invokeMethod('loadTradinPluginSDKWithValues', {'value1':value1, 'value2':value2, 'value3':value3});
   return resultData;
  }

  static Future<String?> get getTradinPluginSDKValues async {
    final String? version = await _channel.invokeMethod('getTradinPluginSDKValues');
    return version;
  }

}
